local uci = require "luci.model.uci".cursor()
local ds = require "luci.dispatcher"
local sys = require "luci.sys"

m = Map("ser2net", "", "")

section_global = m:section(NamedSection, "global", "ser2net", translate("Enable/ Disable"))
section_global.anonymous = true
section_global.addremove = false
section_global.name = "global"

option_enabled = section_global:option(Flag, "enabled", translate("Enabled"), translate("Enable ser2net"))
option_enabled.rmempty=false
option_enabled.anonymous=true
option_enabled.default="1"

s = m:section(TypedSection, "controlport", "Control Port")
s.anonymous = true
option_enabled = s:option(Flag, "enabled", translate("Enabled"), translate("Enable Control Port"))
option_enabled.default = "1"

host = s:option(Value, "host", translate("Host"))
host.datatype = "host"

port = s:option(Value, "port", translate("Port"))
port.datatype = "port"


s = m:section(TypedSection, "default", "Default")
s.anonymous = true

speed = s:option(Value, "speed", translate("Host"))
speed.datatype = "integer"

databits = s:option(ListValue, "databits", translate("Data bits"))
databits:value("5", "5")
databits:value("6", "6")
databits:value("7", "7")
databits:value("8", "8")
databits.default = "8"

parity = s:option(ListValue, "parity", translate("Parity"))
parity:value("none", translate("None"))
parity:value("even", translate("Even"))
parity:value("odd", translate("Odd"))
parity.default = "none"

stopbits = s:option(ListValue, "stopbits", translate("Stop bits"))
stopbits:value("1", "1")
stopbits:value("2", "2")
stopbits.default = "1"

rcstcs = s:option(ListValue, "rcstcs", translate("RCS TCS"))
rcstcs:value("true","true")
rcstcs:value("false","false")

local_conf = s:option(ListValue, "local", translate("Local Configuration"))
local_conf:value("true","true")
local_conf:value("false","false")

remctl = s:option(ListValue, "remctl", translate("Remote Control"))
remctl:value("true","true")
remctl:value("false","false")

--Proxy
s = m:section(TypedSection, "proxy", "Proxy")
s.addremove = true
s.anonymous = true

option_enabled = s:option(Flag, "enabled", translate("Enabled"), translate("Enable Proxy"))
option_enabled.default = "1"

port = s:option(Value, "port", translate("Port"))
port.datatype = "port"

protocol = s:option(ListValue,"protocol", "Protocol")
protocol:value("telnet", "telnet")
protocol:value("raw", "raw")

timeout = s:option(Value, "timeout", translate("Timeout (seconds)"))
timeout.datatype = "range(0,30)"

device = s:option(ListValue, "device", translate("Device Name"))
device:value("/dev/ttyS0", "Serial 1")
device:value("/dev/ttyUSB0", "USB to Serial converter")

baudrate = s:option(ListValue, "baudrate", translate("Baud rate"))
baudrate:value("300", "300")
baudrate:value("1200", "1200")
baudrate:value("2400", "2400")
baudrate:value("4800", "4800")
baudrate:value("9600", "9600")
baudrate:value("19200", "19200")
baudrate:value("38400", "38400")
baudrate:value("57600", "57600")
baudrate:value("115200", "115200")
baudrate.default = "115200"

databits = s:option(ListValue, "databits", translate("Data bits"))
databits:value("5", "5")
databits:value("6", "6")
databits:value("7", "7")
databits:value("8", "8")
databits.default = "8"

parity = s:option(ListValue, "parity", translate("Parity"))
parity:value("none", translate("None"))
parity:value("even", translate("Even"))
parity:value("odd", translate("Odd"))
parity.default = "none"

stopbits = s:option(ListValue, "stopbits", translate("Stop bits"))
stopbits:value("1", "1")
stopbits:value("2", "2")
stopbits.default = "1"

return m
